<script setup>
import { BButton, BLink } from 'bootstrap-vue-next';
import { marked } from 'marked';
import { inject, ref, computed, watch } from 'vue';
import { useRoute, useRouter } from 'vue-router';

import SearchSvg from '@images/empty-search-md.svg';
import ErrorSvg from '@images/status-fail-md.svg';

import ContributorLevelBadge from '~/common/components/ContributorLevelBadge.vue';
import FilterCard from '~/common/components/FilterCard.vue';
import IssueRewardModal from '~/common/components/IssueRewardModal.vue';
import LevelProgress from '~/common/components/LevelProgress.vue';
import { BONUS_POINT_ACTIVITY_TYPES, DEFAULT_TITLE, REWARD_REASONS } from '~/common/Constants';
import { dateFormatter, numberProps } from '~/common/FieldFormats';
import { buildUrl } from '~/common/UrlUtils';

import AddEventModal from './user-page/AddEventModal.vue';
import AddPointsModal from './user-page/AddPointsModal.vue';
import PagedAccordionTable from './user-page/PagedAccordionTable.vue';

const vueData = inject('vueData');
const admin = vueData.userAdmin;

const data = ref({});
const busy = ref(true);
const filterData = ref({
  fromDate: '',
  toDate: '',
});
const error = ref(null);
const showAddPointsModal = ref(false);
const showAddEventModal = ref(false);
const showIssueRewardModal = ref(false);

const route = useRoute();
const userHandle = ref(route.params.userHandle);
watch(() => route.params, (params, oldParams = {}) => {
  if (params['userHandle'] !== oldParams['userHandle']) {
    userHandle.value = params['userHandle'];
    fetchData();
  };
});

const userId = computed(() => data.value.id);
const ownProfile = computed(() => vueData.userId === userId.value);
const levelProgressData = computed(() => {
  return {
    contributorLevel: data.value.contributor_level,
    contributorPoints: data.value.points,
  };
});

const renderer = new marked.Renderer();
const linkRenderer = renderer.link;
renderer.link = (href, title, text) => {
  const html = linkRenderer.call(renderer, href, title, text);
  return html.replace(/^<a /, '<a target="_blank"');
};

const rewardFields = [
  {
    key: 'reason',
    label: 'Reason',
    formatter: value => REWARD_REASONS[value],
  },
  {
    key: 'issue_web_url',
    label: 'Reward issue',
  },
  {
    key: 'credits',
    label: 'Credits',
  },
  {
    key: 'awarded_by',
    label: 'Issued by',
  },
  {
    key: 'created_at',
    label: 'Issued date',
    formatter: dateFormatter,
  },
];

const eventFields = [
  {
    key: 'reason',
    label: 'Details',
  },
  {
    key: 'created_at',
    label: 'Added date',
    formatter: dateFormatter,
  },
  {
    key: 'points',
    label: 'Points',
    ...numberProps,
  },
];

const bonusPointsFields = [
  {
    key: 'activity_type',
    label: 'Activity type',
    formatter: value => BONUS_POINT_ACTIVITY_TYPES[value],
  },
  {
    key: 'reason',
    label: 'Reason',
  },
  {
    key: 'created_at',
    label: 'Awarded date',
    formatter: dateFormatter,
  },
  {
    key: 'points',
    label: 'Points',
    ...numberProps,
  },
];

const mergedMergeRequestFields = [
  {
    key: 'title',
    label: 'Title',
  },
  {
    key: 'opened_date',
    label: 'Open date',
    formatter: dateFormatter,
  },
  {
    key: 'merged_date',
    label: 'Merge date',
    formatter: dateFormatter,
  },
  {
    key: 'has_linked_issue',
    label: 'Linked issue',
  },
];

const openedMergeRequestFields = [
  {
    key: 'title',
    label: 'Title',
  },
  {
    key: 'opened_date',
    label: 'Open date',
    formatter: dateFormatter,
  },
  {
    key: 'state_id',
    label: 'State',
  },
  {
    key: 'has_linked_issue',
    label: 'Linked issue',
  },
];

const commitFields = [
  {
    key: 'merge_request_title',
    label: 'Merge request title',
  },
  {
    key: 'sha',
    label: 'SHA',
  },
  {
    key: 'committed_date',
    label: 'Commit date',
    formatter: dateFormatter,
  },
  {
    key: 'merged_date',
    label: 'Merge date',
    formatter: dateFormatter,
  },
];

const issueFields = [
  {
    key: 'title',
    label: 'Title',
  },
  {
    key: 'opened_date',
    label: 'Open date',
    formatter: dateFormatter,
  },
  {
    key: 'state_id',
    label: 'State',
  },
];

const noteFields = [
  {
    key: 'noteable_title',
    label: 'Noteable title',
  },
  {
    key: 'added_date',
    label: 'Added date',
    formatter: dateFormatter,
  },
];

const discordMessageFields = [
  {
    key: 'added_date',
    label: 'Added date',
    formatter: dateFormatter,
  },
  {
    key: 'reply',
    label: 'Reply',
  },
  {
    key: 'channel',
    label: 'Channel',
  },
];

const forumPostFields = [
  {
    key: 'topic',
    label: 'Topic',
  },
  {
    key: 'reply',
    label: 'Reply',
  },
  {
    key: 'added_date',
    label: 'Added date',
    formatter: dateFormatter,
  },
];

const filter = () => {
  busy.value = true;
  fetchData();
};

if (userHandle.value === 'me') {
  const username = vueData.username?.toString();
  if (username == null) {
    window.location.href = '/login?return=/users/me';
  }

  userHandle.value = username;
  const router = useRouter();
  router.push({
    name: route.name,
    params: { ...route.params, userHandle: username },
    hash: location.hash,
  });
}

const triggerModal = () => {
  if (ownProfile.value && location.hash == '#add-event') {
    showAddEventModal.value = true;
    location.hash = '';
  }
};

const fetchData = async () => {
  const query = { from_date: filterData.value.fromDate, to_date: filterData.value.toDate };
  const url = buildUrl(`/api/v1/users/${userHandle.value}`, { query });

  error.value = null;
  let response;

  try {
    response = await fetch(url);
  } catch (e) {
    error.value = e;
  }

  if (response?.status === 200) {
    data.value = await response.json();
    document.title = `${data.value.username} - ${DEFAULT_TITLE}`;
    triggerModal();
  } else {
    error.value = response.status;
  }

  busy.value = false;
};

const bonusPoints = computed(() => data.value?.bonus_points?.filter(item => item.activity_type !== 'event'));
const events = computed(() => data.value?.bonus_points?.filter(item => item.activity_type === 'event'));
</script>
<template>
  <template v-if="error === 404">
    <div
      class="text-center"
    >
      <img
        :src="SearchSvg"
        alt="Magnifying glass"
      >
      <h2 class="fw-bold">User not found.</h2>
    </div>
    <div>
      If the user has no recent activity, or has not yet been imported, you can view their
      <a
        :href="`https://gitlab.com/${userHandle}`"
        target="_blank"
      >GitLab profile</a>
      directly.
    </div>
  </template>
  <template v-else-if="error">
    <div
      class="text-center"
    >
      <img
        :src="ErrorSvg"
        alt="Magnifying glass"
      >
      <h2 class="text-center fw-bold">Something went wrong.</h2>
    </div>
    <div>
      Please try again later.
      If the problem persists, please raise an issue in the
      <a
        href="https://gitlab.com/gitlab-org/developer-relations/contributor-success/contributors-gitlab-com/-/issues/new?issuable_template=default"
        target="_blank"
      >contributors-gitlab-com issue tracker</a>.
    </div>
  </template>
  <template v-else>
    <FilterCard
      v-model="filterData"
      class="my-2"
      @filter="filter"
    />

    <h1 class="d-flex align-items-center justify-content-between my-2">
      <span>
        <ContributorLevelBadge
          :contributor-level="data.contributor_level"
        />
        <a
          :href="`https://gitlab.com/${data.username}`"
          target="_blank"
        >
          {{ data.username }}
        </a>
      </span>
      <BButton
        v-if="admin && userId"
        variant="outline-primary"
        size="sm"
        :to="{
          name: 'user-edit',
          params: { userId },
        }"
      >
        Edit user
      </BButton>
    </h1>

    <div class="my-2">
      <LevelProgress
        v-if="userId"
        :key="userId"
        :contributor-data="levelProgressData"
      />
    </div>

    <template v-if="Array.isArray(data.rewards)">
      <PagedAccordionTable
        :items="data.rewards"
        :fields="rewardFields"
        :busy="busy"
        sort-key="awarded_date"
        title="Rewards"
      >
        <template #headerButtons>
          <BButton
            v-if="admin"
            variant="outline-primary"
            size="sm"
            class="mx-2"
            @click.stop="showIssueRewardModal = true"
          >
            Issue reward
          </BButton>
        </template>
        <template #cell(issue_web_url)="{ value }">
          <BLink
            is-unsafe-link
            :href="value"
            target="_blank"
          >
            #{{ value.split('/').pop() }}
          </BLink>
        </template>
        <template #cell(awarded_by)="cell">
          <BLink
            is-unsafe-link
            :href="cell.item.awarded_by_web_url"
            target="_blank"
          >
            {{ cell.value }}
          </BLink>
        </template>
      </PagedAccordionTable>
    </template>

    <PagedAccordionTable
      :items="events"
      :fields="eventFields"
      :busy="busy"
      sort-key="created_at"
      title="Events"
    >
      <template #headerButtons>
        <BButton
          v-if="ownProfile"
          variant="outline-primary"
          size="sm"
          class="mx-2"
          @click.stop="showAddEventModal = true"
        >
          Add event
        </BButton>
      </template>
      <template #cell(reason)="{ value }">
        <div v-html="marked(value, { renderer })" />
      </template>
    </PagedAccordionTable>

    <PagedAccordionTable
      :items="bonusPoints"
      :fields="bonusPointsFields"
      :busy="busy"
      sort-key="created_at"
      title="Bonus Points"
    >
      <template #headerButtons>
        <BButton
          v-if="admin"
          variant="outline-primary"
          size="sm"
          class="mx-2"
          @click.stop="showAddPointsModal = true"
        >
          Add points
        </BButton>
      </template>
    </PagedAccordionTable>

    <PagedAccordionTable
      :items="data.merged_merge_requests"
      :fields="mergedMergeRequestFields"
      :busy="busy"
      sort-key="merged_date"
      title="Merged Merge Requests"
    >
      <template #cell(title)="cell">
        <BLink
          is-unsafe-link
          :href="cell.item.web_url"
          target="_blank"
        >
          {{ cell.value }}
        </BLink>
      </template>
      <template #cell(has_linked_issue)="{ value }">
        <span v-if="value">✓</span>
      </template>
    </PagedAccordionTable>

    <PagedAccordionTable
      :items="data.opened_merge_requests"
      :fields="openedMergeRequestFields"
      :busy="busy"
      sort-key="opened_date"
      title="Opened Merge Requests"
    >
      <template #cell(title)="cell">
        <BLink
          is-unsafe-link
          :href="cell.item.web_url"
          target="_blank"
        >
          {{ cell.value }}
        </BLink>
      </template>
      <template #cell(has_linked_issue)="{ value }">
        <span v-if="value">✓</span>
      </template>
    </PagedAccordionTable>

    <PagedAccordionTable
      :items="data.merged_commits"
      :fields="commitFields"
      :busy="busy"
      sort-key="committed_date"
      title="Commits"
    >
      <template #cell(merge_request_title)="cell">
        <BLink
          is-unsafe-link
          :href="cell.item.merge_request_web_url"
          target="_blank"
        >
          {{ cell.value }}
        </BLink>
      </template>
    </PagedAccordionTable>

    <PagedAccordionTable
      :items="data.opened_issues"
      :fields="issueFields"
      :busy="busy"
      sort-key="opened_date"
      title="Opened Issues"
    >
      <template #cell(title)="cell">
        <BLink
          is-unsafe-link
          :href="cell.item.web_url"
          target="_blank"
        >
          {{ cell.value }}
        </BLink>
      </template>
    </PagedAccordionTable>

    <PagedAccordionTable
      :items="data.added_notes"
      :fields="noteFields"
      :busy="busy"
      sort-key="added_date"
      title="Added Notes"
    >
      <template #cell(noteable_title)="cell">
        <BLink
          is-unsafe-link
          :href="cell.item.web_url"
          target="_blank"
        >
          {{ cell.value }}
        </BLink>
      </template>
    </PagedAccordionTable>

    <PagedAccordionTable
      :items="data.discord_messages"
      :fields="discordMessageFields"
      :busy="busy"
      sort-key="added_date"
      title="Discord Messages"
    >
      <template #cell(added_date)="cell">
        <BLink
          is-unsafe-link
          :href="cell.item.web_url"
          target="_blank"
        >
          {{ cell.value }}
        </BLink>
      </template>
      <template #cell(reply)="{ value }">
        <span v-if="value">✓</span>
      </template>
    </PagedAccordionTable>

    <PagedAccordionTable
      :items="data.forum_posts"
      :fields="forumPostFields"
      :busy="busy"
      sort-key="added_date"
      title="Forum Posts"
    >
      <template #cell(topic)="cell">
        <BLink
          is-unsafe-link
          :href="cell.item.web_url"
          target="_blank"
        >
          {{ cell.value }}
        </BLink>
      </template>
      <template #cell(reply)="{ value }">
        <span v-if="value">✓</span>
      </template>
    </PagedAccordionTable>

    <AddEventModal
      v-if="ownProfile"
      v-model="showAddEventModal"
      @event-added="fetchData"
    />

    <AddPointsModal
      v-if="admin && userId"
      v-model="showAddPointsModal"
      :user-id="userId"
      @points-added="fetchData"
    />

    <IssueRewardModal
      v-if="admin && userId"
      v-model="showIssueRewardModal"
      :user-id="userId"
      @reward-issued="fetchData"
    />
  </template>
</template>
